//
//      HelloWorld.c
//

#include <AEEAppGen.h>
#include <AEEStdLib.h>
#include "HelloWorld.bid"

int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj);
static boolean HelloWorld_HandleEvent(AEEApplet* pi, AEEEvent eCode, uint16 wParam, uint32 dwParam);
static void HelloWorld_OnAppStart(AEEApplet* pi, AEEAppStart* environment);
static boolean HelloWorld_OnKey(AEEApplet* pi, uint16 key);

//  Avbg Gg
int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj)
{
    *ppObj = NULL;

    if (ClsId == AEECLSID_HELLOWORLD) {
        if (AEEApplet_New(sizeof(AEEApplet), ClsId, pIShell, po, (IApplet**)ppObj, (AEEHANDLER)HelloWorld_HandleEvent, NULL) == TRUE) {
            return AEE_SUCCESS;
        }
    }
    return EFAILED;
}

//  Cxg nh
static boolean HelloWorld_HandleEvent(AEEApplet* pi, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
    boolean result = FALSE;

    switch (eCode) {
        case EVT_APP_START:
            HelloWorld_OnAppStart(pi, (AEEAppStart*)dwParam);
            result = TRUE;
            break;
        case EVT_KEY:
            result = HelloWorld_OnKey(pi, wParam);
            break;
    }
    return result;
}

//  AvJnnh
static void HelloWorld_OnAppStart(AEEApplet* pi, AEEAppStart* environment)
{
    static AECHAR const text[] = {'H', 'e', 'l', 'l', 'o', ' ', 'W', 'o', 'r', 'l', 'd', '\0'};

    IDISPLAY_DrawText(pi->m_pIDisplay, AEE_FONT_NORMAL, text, -1, 0, 0, NULL, IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE | IDF_TEXT_TRANSPARENT);
    IDISPLAY_Update(pi->m_pIDisplay);
    return;
}

//  L[ nh
static boolean HelloWorld_OnKey(AEEApplet* pi, uint16 key)
{
    boolean result = FALSE;

    switch (key) {
        case AVK_SELECT:
            ISHELL_CloseApplet(pi->m_pIShell, FALSE);
            result = TRUE;
            break;
    }
    return result;
}
