package com.s_cradle.lifeapp;

import com.nttdocomo.ui.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: Sophia Cradle, Inc.</p>
 *
 * @author YOSHIMURA Masaru
 * @version $Id$
 */
public class LifeGameMainPanel extends Panel implements SoftKeyListener, ComponentListener{
  private LifeGameApplication appli;
  private Button startButton;
  private Button editButton;
  private Button saveButton;
  private Button loadButton;
  private Button changeSizeButton;

  public LifeGameMainPanel(LifeGameApplication appli_) {
    appli = appli_;
    //UI̔zu
    add(new Label("Life Game"));
    startButton = new Button("Start");
    add(startButton);
    editButton = new Button("Edit");
    add(editButton);
    saveButton = new Button("Save");
    add(saveButton);
    loadButton = new Button("Load");
    add(loadButton);
    changeSizeButton = new Button("Change size");
    add(changeSizeButton);

    //\tgL[̐ݒ
    setSoftLabel(Frame.SOFT_KEY_2,"I");
    setSoftKeyListener(this);
    setComponentListener(this);
  }

  /**
   * {^ꂽꍇCꂼ̃{^̎󂯎ʑJڂsD
   */
  public void componentAction(Component source, int type, int param) {
    if(type == ComponentListener.BUTTON_PRESSED){
      if(source == startButton){
        appli.changeState(LifeGameApplication.STATE_GAMESTART);
      } else if(source == editButton){
        appli.changeState(LifeGameApplication.STATE_EDIT);
      } else if(source == saveButton){
        appli.changeState(LifeGameApplication.STATE_SAVE);
      } else if(source == loadButton){
        appli.changeState(LifeGameApplication.STATE_LOAD);
      } else if(source == changeSizeButton){
        appli.changeState(LifeGameApplication.STATE_CHANGESIZE);
      }

    }
  }

  /**
   * \tgL[ꂽƂ̏
   */
  public void softKeyPressed(int softKey){
    return;
  }

  /**
   * \tgL[ꂽƂ̏
   */
  public void softKeyReleased(int softKey){
    switch(softKey){
      case Frame.SOFT_KEY_1:
        break;
      case Frame.SOFT_KEY_2:
        appli.terminate();
        break;
    }
  }
}
