#ifndef __LIFEGAMEEDITCANVAS_HPP
#define __LIFEGAMEEDITCANVAS_HPP

#include "LifeGame.hpp"
#include "LifeGameApp.hpp"
#include "SoftKeyWindow.hpp"

class LifeGameEditCanvas : public Window {
private:
    int cursorX;
    int cursorY;
    Matrix& matrix;

public:
    LifeGameEditCanvas(WindowManager* wm_);
    void setCurrent(){ matrix = wm->lifeGame->getMatrix(); }
    void paint();
    void keyPress(uint16 key);
    void next();
};

#endif //__LIFEGAMEEDITCANVAS_HPP
