#ifndef __SOFTKEYWINDOW_HPP
#define __SOFTKEYWINDOW_HPP

#include "LifeGameApp.hpp"
#include "BPPLib.hpp"

class SoftKeyWindow : public Window {
private:
    BPPString textLeft;
    BPPString textCenter;
    BPPString textRight;
    int width;
public:
    SoftKeyWindow(WindowManager* wm_, int width_);
    void paint();
    void setText(const BPPString& textLeft_, const BPPString& textCenter_, const BPPString& textRight_);
    void keyPress(uint16 key) {};
};

#endif //__SOFTKEYWINDOW_HPP
